"""
著作權所有 (C) 民國102年 意傳文化科技
開發者：薛丞宏
網址：http://意傳.台灣
語料來源：請看各資料庫內說明

本程式乃自由軟體，您必須遵照SocialCalc設計的通用公共授權（Common Public Attribution License, CPAL)來修改和重新發佈這一程式，詳情請參閱條文。授權大略如下，若有歧異，以授權原文為主：
	１．得使用、修改、複製並發佈此程式碼，且必須以通用公共授權發行；
	２．任何以程式碼衍生的執行檔或網路服務，必須公開該程式碼；
	３．將此程式的原始碼當函式庫引用入商業軟體，且不需公開非關此函式庫的任何程式碼

此開放原始碼、共享軟體或說明文件之使用或散佈不負擔保責任，並拒絕負擔因使用上述軟體或說明文件所致任何及一切賠償責任或損害。

臺灣言語工具緣起於本土文化推廣與傳承，非常歡迎各界用於商業軟體，但希望在使用之餘，能夠提供建議、錯誤回報或修補，回饋給這塊土地。

感謝您的使用與推廣～～勞力！承蒙！
"""
國語注音符號聲 = {
	'ㄅ','ㄆ','ㄇ','ㄈ','ㄉ','ㄊ','ㄋ','ㄌ',
	'ㄍ','ㄎ','ㄏ','ㄐ','ㄑ','ㄒ',
	'ㄓ','ㄔ','ㄕ','ㄖ','ㄗ','ㄘ','ㄙ','',
}
國語注音符號空韻聲 = {
	'ㄓ','ㄔ','ㄕ','ㄖ','ㄗ','ㄘ','ㄙ',
}
國語注音符號韻 = {
	'','ㄧ','ㄨ','ㄩ',
	'ㄚ','ㄛ','ㄜ','ㄝ','ㄞ','ㄟ','ㄠ','ㄡ','ㄢ','ㄣ','ㄤ','ㄥ','ㄦ',
	'ㄧㄚ','ㄧㄛ','ㄧㄝ','ㄧㄞ','ㄧㄠ','ㄧㄡ','ㄧㄢ','ㄧㄣ','ㄧㄤ','ㄧㄥ',
	'ㄨㄚ','ㄨㄛ','ㄨㄞ','ㄨㄟ','ㄨㄢ','ㄨㄣ','ㄨㄤ','ㄨㄥ',
	'ㄩㄝ','ㄩㄢ','ㄩㄣ','ㄩㄥ',
		}
國語注音符號調 = {'','ˊ','ˇ','ˋ','˙',}

#########################################
#  2013/11/1→12/13
#  意傳的客家話辨識用拼音→國語注音符號
#########################################
class 國語注音符號:

	#-------成員函式--------#
	def __init__(self, 音標):
		# self.腔
		self.音標 = None
		if 音標[-1:] in self.調類對照表:
			for 所在 in range(len(音標) - 1):
				if 音標[:所在] in self.聲母對照表 and 音標[所在:-1] in self.韻母對照表:
					self.聲 = 音標[:所在]
					self.韻 = 音標[所在:-1]
					self.調 = 音標[-1:]
					self.聲韻 = 音標[:-1]
					self.音標 = 音標
			if 音標[:-1] in self.空韻聲:
				self.聲 = 音標[:-1] 
				self.韻 = ''
				self.調 = 音標[-1:]
				self.聲韻 = 音標[:-1]
				self.音標 = 音標
		else:  # :調是1聲
			for 所在 in range(len(音標)):
				if 音標[:所在] in self.聲母對照表 and 音標[所在:] in self.韻母對照表:
					self.聲 = 音標[:所在]
					self.韻 = 音標[所在:]
					self.調 = ''
					self.聲韻 = 音標
					self.音標 = 音標
			if 音標 in self.空韻聲:
				self.聲 = 音標
				self.韻 = ''
				self.調 = ''
				self.聲韻 = 音標
				self.音標 = 音標
		if self.韻=='' and self.聲 not in self.空韻聲:
			self.音標 = None
	def 標準音標(self):
		return self.音標
	#-------成員變數--------#
	音標上長長度 = 5
	聲 = None
	韻 = None
	聲韻 = None
	調 = None
	音標 = None
	聲母對照表 = 國語注音符號聲
	韻母對照表 = 國語注音符號韻
	調類對照表 = 國語注音符號調
	空韻聲=國語注音符號空韻聲


